use strict;

require "backends/pnpdump.pl";

sub hackcheck {
  my($pnp) = @_;

  my($hacklist);
  my($ldn) = 0;
  my($brd);
  for $brd (1 .. $#{$pnp->{board}}) {
    my($board) = $pnp->{board}[$brd];
    for $ldn ($board->{first_ld} .. $#{$board->{ld}}) {
      my($ld) = $board->{ld}[$ldn];
      if(($board->{name} =~ /Creative .*(SB32|AWE32|AWE64)/) &&
		($ld->{name} =~/Wave[Tt]able/) &&
		($#{$ld->{profile}[0]{io}} == 0)) {
        $hacklist->[$#{$hacklist} + 1] = ["AWE synth", $brd, $ldn];
      }
    }
  }
  $hacklist;
}

sub dohack {
  my($pnp, $hackdesc) = @_;

  my($hackname,$brd,$ldn) = @{$hackdesc};

  my($ld) = $pnp->{board}[$brd]{ld}[$ldn];
  if($hackname eq "AWE synth") {
    my($i);
    for $i (0 .. $#{$ld->{profile}}) {
      my($profile) = $ld->{profile}[$i];
      my($j);
      for $j (1 .. 2) {
        $profile->{io}[$j] = {};
        my($resource) = $profile->{io}[$j];
        $resource->{addr_min} = $profile->{io}[0]{addr_min} + (1024 * $j);
        $resource->{addr_max} = $profile->{io}[0]{addr_max} + (1024 * $j);
        $resource->{addr_align} = $profile->{io}[0]{addr_align};
        $resource->{window_size} = $profile->{io}[0]{window_size};
        $resource->{fixed} = $profile->{io}[0]{fixed};
      }
    }
    $pnp->{verifyld} = 0;
  }
  &build_currentrecs($pnp);
}

1;
